Bug 444906 - gdm-binary consumes 100% of its CPU
gdm-binary consumes 100% of its CPU
Status: CLOSED NOTABUG
Product: Red Hat Enterprise MRG
Classification: Red Hat
Component: realtime-kernel (Show other bugs)
beta
i686 Linux
low Severity low
: ---
: ---
Assigned To: Clark Williams
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-05-01 14:03 EDT by Tony Musgrave
Modified: 2008-10-28 08:25 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-10-28 08:25:16 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Tony Musgrave 2008-05-01 14:03:44 EDT
From Bugzilla Helper:
User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; .NET CLR 1.0.3705; .NET CLR 1.1.4322; .NET CLR 2.0.50727)

Description of problem:
After booting up MRG Realtime (2.6.24.1-24.el5rt kernel) on a 2-way HP ProLiant DL380 G4 server, "top" shows that gdm-binary is consuming 100% of a CPU.

gdm-binary consumes very little CPU, however, if I reboot into RHEL5.1.
Nor do I recall ever seeing gdm-binary consume 100% CPU when running the RHEL-RT precursor to MRG Realtime.

I've also installed an even newer version of MRG Realtime (2.6.24.4-30.el5rt kernel), using RHEL5.2 (2.6.18-88.el5PAE kernel) as a foundation, instead of RHEL5.1 (2.6.18-prep kernel).

Again, every time I boot from this newer MRG Realtime, top shows gdm-binary running at or very close to 100% CPU utilization.  After rebooting from RHEL5.2, "top" doesn't even show gdm-binary on the first page.

Version-Release number of selected component (if applicable):


How reproducible:
Always


Steps to Reproduce:
1.  Install RHEL5.1 or RHEL5.2.
2.  Install MRG Realtime.
3.  Reboot and run "top", and look for gdm-binary.

Actual Results:


Expected Results:


Additional info:
Here's the version of gdm:
rpm -qf /usr/sbin/gdm-binary
gdm-2.16.0-46.el5

Here's what strace says after running for about 30 seconds:
strace -c -p 7934
Process 7934 attached - interrupt to quit
Process 7934 detached
% time     seconds  usecs/call     calls    errors syscall
------ ----------- ----------- --------- --------- ----------------
 51.09    0.069785           0   1067897           ioctl
 48.91    0.066812           0   1072069           poll
------ ----------- ----------- --------- --------- ----------------
100.00    0.136597               2139966           total

strace -p <PID of gdm-binary> lists these 2 lines, over and over:
poll([{fd=12, events=POLLIN, revents=POLLNVAL}, {fd=3, events=POLLIN}], 2, -1) = 1
ioctl(3, FIONREAD, [0])                 = 0

where fd 3 refers to a Unix domain socket.
Comment 1 Clark Williams 2008-05-27 12:09:33 EDT
Can you give me an '/sbin/lspci -v' from this system? I'm wondering what kind of
graphics chipset is there (as well as the other chipsets), since it sounds like
gdm-binary is just spinning away on the input routine. 
Comment 2 Tony Musgrave 2008-05-28 16:41:25 EDT
(In reply to comment #1)
> Can you give me an '/sbin/lspci -v' from this system? I'm wondering what kind 
of
> graphics chipset is there (as well as the other chipsets), since it sounds 
like
> gdm-binary is just spinning away on the input routine. 

Clark,

I've since updated MRG to 2.6.24.4-47.el5rt, and top continues to show gdm-
binary running at 100% CPU.  Below is the output of "lspci -v".

[root@asd25 ~]# /sbin/lspci -v
00:00.0 Host bridge: Intel Corporation E7520 Memory Controller Hub (rev 0c)
        Subsystem: Compaq Computer Corporation Unknown device 3200
        Flags: bus master, fast devsel, latency 0
        Capabilities: [40] Vendor Specific Information

00:02.0 PCI bridge: Intel Corporation E7525/E7520/E7320 PCI Express Port A (rev 
0c) (prog-if 00 [Normal decode])
        Flags: bus master, fast devsel, latency 0
        Bus: primary=00, secondary=02, subordinate=04, sec-latency=0
        I/O behind bridge: 00004000-00004fff
        Memory behind bridge: fde00000-fdffffff
        Prefetchable memory behind bridge: 00000000f0000000-00000000f0000000
        Capabilities: [50] Power Management version 2
        Capabilities: [58] Message Signalled Interrupts: 64bit- Queue=0/1 
Enable-
        Capabilities: [64] Express Root Port (Slot-) IRQ 0
        Capabilities: [100] Advanced Error Reporting

00:06.0 PCI bridge: Intel Corporation E7520 PCI Express Port C (rev 0c) (prog-
if 00 [Normal decode])
        Flags: bus master, fast devsel, latency 0
        Bus: primary=00, secondary=05, subordinate=0c, sec-latency=0
        Memory behind bridge: f0100000-f02fffff
        Prefetchable memory behind bridge: 00000000fb900000-00000000fbd00000
        Capabilities: [50] Power Management version 2
        Capabilities: [58] Message Signalled Interrupts: 64bit- Queue=0/1 
Enable-
        Capabilities: [64] Express Root Port (Slot+) IRQ 0
        Capabilities: [100] Advanced Error Reporting

00:1d.0 USB Controller: Intel Corporation 82801EB/ER (ICH5/ICH5R) USB UHCI 
Controller #1 (rev 02) (prog-if 00 [UHCI])
        Subsystem: Compaq Computer Corporation Unknown device 3201
        Flags: bus master, medium devsel, latency 0, IRQ 16
        I/O ports at 3000 [size=32]

00:1d.1 USB Controller: Intel Corporation 82801EB/ER (ICH5/ICH5R) USB UHCI 
Controller #2 (rev 02) (prog-if 00 [UHCI])
        Subsystem: Compaq Computer Corporation Unknown device 3201
        Flags: bus master, medium devsel, latency 0, IRQ 18
        I/O ports at 3020 [size=32]

00:1d.2 USB Controller: Intel Corporation 82801EB/ER (ICH5/ICH5R) USB UHCI 
Controller #3 (rev 02) (prog-if 00 [UHCI])
        Subsystem: Compaq Computer Corporation Unknown device 3201
        Flags: bus master, medium devsel, latency 0, IRQ 19
        I/O ports at 3040 [size=32]

00:1d.3 USB Controller: Intel Corporation 82801EB/ER (ICH5/ICH5R) USB UHCI 
Controller #4 (rev 02) (prog-if 00 [UHCI])
        Subsystem: Compaq Computer Corporation Unknown device 3201
        Flags: bus master, medium devsel, latency 0, IRQ 16
        I/O ports at 3060 [size=32]

00:1d.7 USB Controller: Intel Corporation 82801EB/ER (ICH5/ICH5R) USB2 EHCI 
Controller (rev 02) (prog-if 20 [EHCI])
        Subsystem: Compaq Computer Corporation Unknown device 3201
        Flags: bus master, medium devsel, latency 0, IRQ 17
        Memory at fbef0000 (32-bit, non-prefetchable) [size=1K]
        Capabilities: [50] Power Management version 2
        Capabilities: [58] Debug port

00:1e.0 PCI bridge: Intel Corporation 82801 PCI Bridge (rev c2) (prog-if 00 
[Normal decode])
        Flags: bus master, fast devsel, latency 0
        Bus: primary=00, secondary=01, subordinate=01, sec-latency=64
        I/O behind bridge: 00001000-00002fff
        Memory behind bridge: fbf00000-fcffffff

00:1f.0 ISA bridge: Intel Corporation 82801EB/ER (ICH5/ICH5R) LPC Interface 
Bridge (rev 02)
        Flags: bus master, medium devsel, latency 0

00:1f.1 IDE interface: Intel Corporation 82801EB/ER (ICH5/ICH5R) IDE Controller 
(rev 02) (prog-if 8a [Master SecP PriP])
        Subsystem: Compaq Computer Corporation Unknown device 3201
        Flags: bus master, medium devsel, latency 0, IRQ 255
        I/O ports at 01f0 [size=8]
        I/O ports at 03f4 [size=1]
        I/O ports at 0170 [size=8]
        I/O ports at 0374 [size=1]
        I/O ports at 0500 [size=16]
        Memory at f0300000 (32-bit, non-prefetchable) [size=1K]

01:03.0 VGA compatible controller: ATI Technologies Inc Rage XL (rev 27) (prog-
if 00 [VGA controller])
        Subsystem: Compaq Computer Corporation Proliant Rage XL
        Flags: bus master, stepping, medium devsel, latency 64
        Memory at fc000000 (32-bit, non-prefetchable) [size=16M]
        I/O ports at 2000 [size=256]
        Memory at fbff0000 (32-bit, non-prefetchable) [size=4K]
        [virtual] Expansion ROM at fbf80000 [disabled] [size=128K]
        Capabilities: [5c] Power Management version 2

01:04.0 System peripheral: Compaq Computer Corporation Integrated Lights Out 
Controller (rev 01)
        Subsystem: Compaq Computer Corporation Unknown device b206
        Flags: medium devsel, IRQ 5
        I/O ports at 1800 [size=256]
        Memory at fbfe0000 (32-bit, non-prefetchable) [size=512]
        Capabilities: [f0] Power Management version 2

01:04.2 System peripheral: Compaq Computer Corporation Integrated Lights Out  
Processor (rev 01)
        Subsystem: Compaq Computer Corporation Unknown device b206
        Flags: bus master, stepping, medium devsel, latency 64, IRQ 5
        I/O ports at 2400 [size=256]
        Memory at fbfd0000 (32-bit, non-prefetchable) [size=2K]
        Memory at fbfc0000 (32-bit, non-prefetchable) [size=8K]
        Memory at fbf00000 (32-bit, non-prefetchable) [size=512K]
        [virtual] Expansion ROM at fbfa0000 [disabled] [size=64K]
        Capabilities: [f0] Power Management version 2

02:00.0 PCI bridge: Intel Corporation 6700PXH PCI Express-to-PCI Bridge A (rev 
09) (prog-if 00 [Normal decode])
        Flags: bus master, fast devsel, latency 0
        Bus: primary=02, secondary=03, subordinate=03, sec-latency=64
        Memory behind bridge: fde00000-fdefffff
        Capabilities: [44] Express PCI/PCI-X Bridge IRQ 0
        Capabilities: [5c] Message Signalled Interrupts: 64bit+ Queue=0/0 
Enable-
        Capabilities: [6c] Power Management version 2
        Capabilities: [d8] PCI-X bridge device
        Capabilities: [100] Advanced Error Reporting
        Capabilities: [300] Power Budgeting

02:00.2 PCI bridge: Intel Corporation 6700PXH PCI Express-to-PCI Bridge B (rev 
09) (prog-if 00 [Normal decode])
        Flags: bus master, fast devsel, latency 0
        Bus: primary=02, secondary=04, subordinate=04, sec-latency=64
        I/O behind bridge: 00004000-00004fff
        Memory behind bridge: fdf00000-fdffffff
        Prefetchable memory behind bridge: 00000000f0000000-00000000f0000000
        Capabilities: [44] Express PCI/PCI-X Bridge IRQ 0
        Capabilities: [5c] Message Signalled Interrupts: 64bit+ Queue=0/0 
Enable-
        Capabilities: [6c] Power Management version 2
        Capabilities: [d8] PCI-X bridge device
        Capabilities: [100] Advanced Error Reporting
        Capabilities: [300] Power Budgeting

03:01.0 Ethernet controller: Broadcom Corporation NetXtreme BCM5704 Gigabit 
Ethernet (rev 10)
        Subsystem: Compaq Computer Corporation NC7782 Gigabit Server Adapter 
(PCI-X, 10,100,1000-T)
        Flags: bus master, 66MHz, medium devsel, latency 64, IRQ 23
        Memory at fdef0000 (64-bit, non-prefetchable) [size=64K]
        Expansion ROM at <ignored> [disabled]
        Capabilities: [40] PCI-X non-bridge device
        Capabilities: [48] Power Management version 2
        Capabilities: [50] Vital Product Data
        Capabilities: [58] Message Signalled Interrupts: 64bit+ Queue=0/3 
Enable-

03:01.1 Ethernet controller: Broadcom Corporation NetXtreme BCM5704 Gigabit 
Ethernet (rev 10)
        Subsystem: Compaq Computer Corporation NC7782 Gigabit Server Adapter 
(PCI-X, 10,100,1000-T)
        Flags: bus master, 66MHz, medium devsel, latency 64, IRQ 24
        Memory at fdee0000 (64-bit, non-prefetchable) [size=64K]
        Expansion ROM at <ignored> [disabled]
        Capabilities: [40] PCI-X non-bridge device
        Capabilities: [48] Power Management version 2
        Capabilities: [50] Vital Product Data
        Capabilities: [58] Message Signalled Interrupts: 64bit+ Queue=0/3 
Enable-

04:03.0 RAID bus controller: Compaq Computer Corporation Smart Array 64xx (rev 
01)
        Subsystem: Compaq Computer Corporation Smart Array 6i
        Flags: bus master, 66MHz, medium devsel, latency 64, IRQ 20
        Memory at fdff0000 (64-bit, non-prefetchable) [size=8K]
        I/O ports at 4000 [size=256]
        Memory at fdf80000 (64-bit, non-prefetchable) [size=256K]
        [virtual] Expansion ROM at f0000000 [disabled] [size=256K]
        Capabilities: [d0] Power Management version 2
        Capabilities: [dc] PCI-X non-bridge device
        Capabilities: [f0] Vital Product Data

05:00.0 PCI bridge: Intel Corporation 6700PXH PCI Express-to-PCI Bridge A (rev 
09) (prog-if 00 [Normal decode])
        Flags: bus master, fast devsel, latency 0
        Bus: primary=05, secondary=06, subordinate=09, sec-latency=64
        Memory behind bridge: f0100000-f01fffff
        Prefetchable memory behind bridge: 00000000fb900000-00000000fba00000
        Capabilities: [44] Express PCI/PCI-X Bridge IRQ 0
        Capabilities: [5c] Message Signalled Interrupts: 64bit+ Queue=0/0 
Enable-
        Capabilities: [6c] Power Management version 2
        Capabilities: [d8] PCI-X bridge device
        Capabilities: [100] Advanced Error Reporting
        Capabilities: [300] Power Budgeting

05:00.2 PCI bridge: Intel Corporation 6700PXH PCI Express-to-PCI Bridge B (rev 
09) (prog-if 00 [Normal decode])
        Flags: bus master, fast devsel, latency 0
        Bus: primary=05, secondary=0a, subordinate=0c, sec-latency=64
        Memory behind bridge: f0200000-f02fffff
        Prefetchable memory behind bridge: 00000000fbb00000-00000000fbd00000
        Capabilities: [44] Express PCI/PCI-X Bridge IRQ 0
        Capabilities: [5c] Message Signalled Interrupts: 64bit+ Queue=0/0 
Enable-
        Capabilities: [6c] Power Management version 2
        Capabilities: [d8] PCI-X bridge device
        Capabilities: [100] Advanced Error Reporting
        Capabilities: [300] Power Budgeting

06:01.0 Ethernet controller: S2io Inc. Xframe 10 Gigabit Ethernet PCI-X (rev 04)
        Subsystem: Hewlett-Packard Company PCI-X 133MHz 10GbE SR Fiber
        Flags: bus master, 66MHz, medium devsel, latency 64, IRQ 21
        Memory at fbaf0000 (64-bit, prefetchable) [size=16K]
        Memory at fb900000 (64-bit, prefetchable) [size=1M]
        [virtual] Expansion ROM at f0100000 [disabled] [size=1M]
        Capabilities: [40] Message Signalled Interrupts: 64bit+ Queue=0/5 
Enable-
        Capabilities: [50] Vital Product Data
        Capabilities: [60] PCI-X non-bridge device
        Capabilities: [80] Power Management version 2

0a:01.0 Ethernet controller: S2io Inc. Xframe II 10Gbps Ethernet (rev 02)
        Subsystem: Hewlett-Packard Company PCI-X 266MHz 10GigE SR [AD385A]
        Flags: bus master, 66MHz, medium devsel, latency 64, IRQ 22
        Memory at fbdf0000 (64-bit, prefetchable) [size=32K]
        Memory at fbc00000 (64-bit, prefetchable) [size=1M]
        Memory at fbbf0000 (64-bit, prefetchable) [size=2K]
        [virtual] Expansion ROM at f0200000 [disabled] [size=1M]
        Capabilities: [40] Message Signalled Interrupts: 64bit+ Queue=0/5 
Enable-
        Capabilities: [60] PCI-X non-bridge device
        Capabilities: [80] Vital Product Data
        Capabilities: [90] MSI-X: Enable- Mask- TabSize=64
        Capabilities: [a0] Power Management version 3

[root@asd25 ~]# 
Comment 3 Michal Schmidt 2008-07-02 07:41:02 EDT
(In reply to comment #0)
> strace -p <PID of gdm-binary> lists these 2 lines, over and over:
> poll([{fd=12, events=POLLIN, revents=POLLNVAL}, {fd=3, events=POLLIN}], 2, -1) = 1
> ioctl(3, FIONREAD, [0])                 = 0
> 
> where fd 3 refers to a Unix domain socket.

There was no event reported by poll on fd 3. But revents=POLLNVAL for fd 12
means that the fd was invalid (closed fd). I don't know why gdm passes a closed
fd to poll. Could you attach to it with gdb and generate a backtrace? Preferably
with gdm-debuginfo installed. It could be a bug in gdm which only shows up with
the RT kernel.
Comment 4 Tony Musgrave 2008-07-21 14:43:38 EDT
Unfortunately, the server where gdm-binary exhibited this unusual 100% CPU 
usage is being moved to another building, and so I temporarily am unable to 
attach gdb to gdm.

It may be a few weeks before this server is available to me, but when it is, I 
will collect the additional info requested.

Tony
Comment 5 Clark Williams 2008-09-15 23:15:56 EDT
Where are we with this bug? Can it be reproduced on a newer kernel (e.g. 2.6.24.7-74.el5rt)?
Comment 6 Clark Williams 2008-10-28 08:25:16 EDT
closing due to no reproducer

Note You need to log in before you can comment on or make changes to this bug.